VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "OpenSave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'                            Classe: OpenSave   (versione 1.2)
'
'Questa classe sostituisce, solo in parte, l'uso del controllo  COMDLG32.OCX
'              (per alcuni esempi di utilizzo, vedi progetto allegato).
'
'=====================================================
' >>>>>>>>>>>>>>>>>        www.vbscuola.it      <<<<<<<<<<<<<<<<<
'=====================================================
'      By Claudio Gucchierato novembre 2003 (for vbscuola.it)
'      modificato alla versione 1.2 aprile 2004

'=========================   NETIQUETTE  ===================
'Sarebbe cosa gradita, ma non obbligatoria, che gli utilizzatori di questa classe
'   citassero nel loro progetto la provenienza del materiale utilizzato.  GRAZIE.
'=========================================================
' Per suggerimenti, consigli e/o osservazioni potete scrivere a: info@vbscuola.it


Option Explicit

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long


Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type


Public Enum CD_OpenSaveFlags
    cdlOFNAllowMultiselect = &H200 ' consente selezioni di file multiple.
    cdlOFNCreatePrompt = &H2000 'chiede la conferma per la creazione di un file che non esiste
    cdlOFNExplorer = &H80000 'Visualizza la finestra tipo Explorer
    cdlOFNExtensionDifferent = &H400
    cdlOFNFileMustExist = &H1000 'consente di immettere solo nomi di file esistenti
    cdlOFNHelpButton = &H10 'visualizza il pulsante di guida
    cdlOFNHideReadOnly = &H4 'nasconde la casella di controllo "Apri in sola lettura"
    cdlOFNLongNames = &H200000 'consente l'uso dei nomi lunghi per i file
    cdlOFNNoChangeDir = &H8 'forza la dir corrente = alla dir al momento dell'apertura della finestra
    cdlOFNNoDereferenceLinks = &H100000
    cdlOFNNoLongNames = &H40000 'disabilita l'uso dei nomi lunghi per i file
    cdlOFNNoReadOnlyReturn = &H8000
    cdlOFNNoValidate = &H100 'accetta caratteri non validi nel nome del file immesso
    cdlOFNOverwritePrompt = &H2 'usato con la finestra "Salva" visualizza un messaggio nel caso il file esista gi
    cdlOFNPathMustExist = &H800 'consente di immettere solo nomi di percorsi validi.
    cdlOFNReadOnly = &H1 'seleziona la casella di spunta "Apri in sola lettura"
    cdlOFNShareAware = &H4000 'indica che la possibile violazione di condivisione deve essere ignorata.
End Enum
'note:
'cdlOFNFileMustExist: con il flag impostato se viene immesso un nome di un file non valido compare un messaggio
'di avviso. Questo flag imposta automaticamente anche il flag cdlOFNPathMustExist

'cdlOFNCreatePrompt:' Questo flag imposta automaticamente anche  i flag  cdlOFNFileMustExist, cdlOFNPathMustExist
'cdlOFNReadOnly : il flag indica anche lo stato della casella "apri in sola lettura" quando la finestra viene chiusa

Private RetValue As Long
Private Const MAX_PATH = 260
Private OFN As OPENFILENAME
Private mFileName As String
Private mStartFileName As String
Private mhOwner As Long
Private mDialogTitle As String
Private mFilter As String
Private mInitDir As String
Private mDefaultExt As String
Private mFilterIndex As Long

Private Sub Class_Initialize()
    mDefaultExt = ""
    mInitDir = ""
    mFileName = ""
    mFilterIndex = 0
End Sub

Public Property Let Filter(sFilter As String)
   mFilter = sFilter 'filtro di selezione
End Property

Public Property Get FileName() As String
   FileName = mFileName 'nome e percorso del file restituito dalla finestra open/save
End Property

Public Property Let DialogTitle(sTitle As String)
   mDialogTitle = sTitle 'titolo della finestra
End Property

Public Property Let hOwner(ByVal New_hOwner As Long)
    mhOwner = New_hOwner 'handle finestra
End Property

Public Property Let DefaultExt(sDefExt As String)
   mDefaultExt = sDefExt
End Property

Public Property Let InitDir(sDir As String)
    mInitDir = sDir 'percorso di partenza
End Property

Public Property Get FilterIndex() As Long
   FilterIndex = mFilterIndex
End Property

Public Property Let FilterIndex(lIndex As Long)
    mFilterIndex = lIndex 'indice del filtro da visualizzare 1,2,3...primo, secondo terzo filtro..
End Property

Public Property Let StartFileName(sFileName As String)
   mStartFileName = sFileName 'nome del file predeterminato (eventuale)
End Property





Private Sub InitOFN()
'NB: i flags impostati sono i flag di pi comune utilizzo.
  Dim sTemp As String, i As Integer
  With OFN
       .lStructSize = Len(OFN) 'ok
       .hwndOwner = mhOwner 'ok
       .flags = 0       '\\\standard flags
       .flags = .flags Or cdlOFNFileMustExist
       .flags = .flags Or cdlOFNHideReadOnly
       .flags = .flags Or cdlOFNPathMustExist
       
       '.flags = .flags Or cdlOFNNoChangeDir  ''forza la dir corrente = alla dir al momento dell'apertura della finestra
        
        'flags da usare nella selezione multipla
        '.flags = .flags Or cdlOFNAllowMultiselect Or cdlOFNExplorer

       .lpstrDefExt = mDefaultExt
       
       sTemp = mInitDir
       If sTemp = "" Then sTemp = App.Path
       .lpstrInitialDir = sTemp
       
       
       
       sTemp = mStartFileName
       .lpstrFile = sTemp & String$(255 - Len(sTemp), 0)
       .nMaxFile = 255
       .lpstrFileTitle = String$(255, 0)
       .nMaxFileTitle = 255
        sTemp = mFilter
        For i = 1 To Len(sTemp)
            If Mid(sTemp, i, 1) = "|" Then
               Mid(sTemp, i, 1) = vbNullChar
            End If
        Next
        sTemp = sTemp & String$(2, 0)
        .lpstrFilter = sTemp
        .nFilterIndex = mFilterIndex
        
        .lpstrTitle = mDialogTitle
        .hInstance = App.hInstance
 End With
End Sub

Public Sub ShowOpen()
'Visualizza la finestra "Apri"
  Dim iDelim As Integer
  InitOFN
  RetValue = GetOpenFileName(OFN)
  If RetValue > 0 Then
     iDelim = InStr(OFN.lpstrFile, vbNullChar)
     If iDelim Then mFileName = Left$(OFN.lpstrFile, iDelim - 1)
          
     '*** da usare nella selezione multipla
     'If InStr(OFN.lpstrFile, Chr$(0)) > 0 Then
     '  mFileName = Trim(Left$(OFN.lpstrFile, InStr(OFN.lpstrFile, Chr$(0) & Chr$(0)) - 1))
     'End If
  Else
     mFileName = ""
  End If
End Sub

Public Sub ShowSave()
'Visualizza la finestra "Salva"
  Dim iDelim As Integer
    InitOFN 'verificare i flags impostati
    RetValue = GetSaveFileName(OFN)
    'MsgBox OFN.nFilterIndex
    If RetValue > 0 Then
        iDelim = InStr(OFN.lpstrFile, vbNullChar)
        If iDelim Then mFileName = Left$(OFN.lpstrFile, iDelim - 1)
    Else
        mFileName = ""
  End If
End Sub

